package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10082ChuKuNewWineResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10082SendBeanWine;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10082ChukuNewWine extends ProtBase {

	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10082 = 10082;

	private Gson gson;
	
	public Prot10082ChukuNewWine(){
		gson = new Gson();
	}
	
	
	private Prot10082ChuKuNewWineResult res;

	

	public Prot10082ChuKuNewWineResult getRes() {
		return res;
	}

	public void setRes(Prot10082ChuKuNewWineResult res) {
		this.res = res;
	}

	public void dealChuKuNewWine(SocketCreate create,
                                 Prot10082SendBeanWine chukuBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), chukuBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10082SendBeanWine chukuBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10082, "开始发送出库信息");
				sendProt(dos, chukuBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10082, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10082, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10082ChuKuNewWineResult.class);
		}
		recCheckCode(dis);
	}

	
	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos,
			Prot10082SendBeanWine chukuBean) throws IOException {
		System.out.println("---bodyContent之前"+chukuBean);		
		String bodyContent = gson.toJson(chukuBean).toString();
		System.out.println("---bodyContent之后"+bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10082, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));		
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}


}
